/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package hu.intersoft.edms.countryAdmin;
import hu.intersoft.hw.entity.Country;
import hu.intersoft.hw.entity.Currency;
import hu.intersoft.cutil.HellowWordUtil;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.faces.context.FacesContext;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;

import org.richfaces.component.html.HtmlExtendedDataTable;
import org.richfaces.model.selection.SimpleSelection;
import org.richfaces.model.DataProvider;
import org.richfaces.model.ExtendedTableDataModel;
import org.richfaces.model.selection.Selection;


/**
 *
 * @author Joco
 */
public class CountryAdminManagedBean {
    List<SelectItem> countryCombo = null;
    private Long currencyId;
    private Currency currency ;
    private Country entity;

    private Long id;          // id of Country
    private String myAction = "";
    private String message;

    private String sortMode="single";
    private String selectionMode="single";
    
    private Selection selection = new SimpleSelection();

    private List<Currency> currencies = new ArrayList<Currency>();

    private ExtendedTableDataModel<Currency> dataModel;

    private Object tableState;


    private List<Currency> selectedCurrency = new ArrayList<Currency>();
    public Object getTableState() {
           return tableState;
    }

    public void setTableState(Object tableState) {
       this.tableState = tableState;
    }


    public String getSortMode() {
           return sortMode;
    }

    public void setSortMode(String sortMode) {
        this.sortMode = sortMode;
    }

    public String getSelectionMode() {
      return selectionMode;
     }

	public void setSelectionMode(String selectionMode) {
		this.selectionMode = selectionMode;
	}

    public List<Currency> getCurrencies() {
        return currencies;
    }

    public void setCurrencies(List<Currency> currencies) {
        this.currencies = currencies;
    }

    public Currency getCurrency() {
        return currency;
    }

    public void setCurrency(Currency currency) {
        this.currency = currency;
    }


    public void onselectionchange() {
        System.out.println("......onselectionchange()........");
    }
public void takeSelection(){
        System.out.println("......takeSelection!!!!!!!!!!!!!!!!!........");
 selectedCurrency.clear();
 Iterator<Object> iterator = getSelection().getKeys();
 while (iterator.hasNext()) {
 Object key = iterator.next();
 selectedCurrency.add(getCurrenciesDataModel().getObjectByKey(key));
 }
  currency = (Currency)selectedCurrency.get(0);
 }


public void setSelection(Selection selection) {
        this.selection = selection;
    }

    public Selection getSelection() {
        return selection;
    }

    public ExtendedTableDataModel<Currency> getCurrenciesDataModel() {
	if (dataModel == null && currencies.size() > 0) {
        System.out.println("......dataModel = null........currencies.size(): " + currencies.size());
	    dataModel = new ExtendedTableDataModel<Currency>(new DataProvider<Currency>() {
				private static final long serialVersionUID = 5054087821033164847L;

				public Currency getItemByKey(Object key) {
                                    System.out.println(".....getItemByKey " );
					for(Currency c : currencies){
						if (key.equals(getKey(c))){
							return c;
						}
					}
					return null;
				}

				public List<Currency> getItemsByRange(int firstRow, int endRow) {
                                    System.out.println("......getItemsByRange " + firstRow + " - " +  endRow);
                                        List<Currency> l = currencies.subList(firstRow, endRow);
                                    System.out.println("......sublist= " + l.size());

					return currencies.subList(firstRow, endRow);
				}

				public Object getKey(Currency item) {
					return item.getName();
				}

				public int getRowCount() {
                                    System.out.println("......getRowCount " + currencies.size() + "..........");

					return currencies.size();
				}

			});
		}
        if (dataModel != null){
        System.out.println("......dataModel: " + dataModel.getRowCount() + "..........");
        }
		return dataModel;
	}

    public CountryAdminManagedBean() {
      countryCombo = populateCountryCombo();
    }

    public List<SelectItem> getCountryCombo() {
        return countryCombo;
    }

    public void setCountryCombo(List<SelectItem> countryCombo) {
        this.countryCombo = countryCombo;
    }

    public Long getCurrencyId() {
        return currencyId;
    }
    public void setCurrencyId(Long currencyId) {
        this.currencyId = currencyId;
    }
    public Country getEntity() {
      if (entity == null) {
          entity = new Country();
      }
      return entity;
    }

    public void setEntity(Country entity) {
        this.entity = entity;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public String getMyAction() {
        return myAction;
    }

    public void setMyAction(String myAction) {
        this.myAction = myAction;
    }
    public void countryChanged(ValueChangeEvent event) {
        dataModel = null;
        id = Long.valueOf(event.getNewValue().toString());
        System.out.println("-------------countryChanged: " + id);
        HellowWordUtil hwu = new HellowWordUtil();
        entity = hwu.getCountryById(id);
        if (entity.getId() == 0) {
            myAction = "new";
            currencies = null;
        } else {
            myAction = "edit";
            currencies = entity.getCurrencyList();
        }
        message = "";
    }
    private List<SelectItem> populateCountryCombo() {
        List<SelectItem> retList = new ArrayList<SelectItem>();
        List<Country> countryList = new HellowWordUtil().getAllCountryList();
        for (int i = 0; i < countryList.size(); i++) {
            Country country = countryList.get(i);
            retList.add(new SelectItem(country.getId(), country.getName(), country.getName()));
        }
        return retList;
    }

    public List<Currency> getListCurrency() {
        return currencies;
    }

    public String addCurrency() {
        myAction = "addCurrency";
        message = "";
        return "viewCurrency";
    }
    public String createCurrency() {
        myAction = "newCurrency";
        message = "";
        return "viewCountry";
    }
    public String updateCurrency() {
        myAction = "updCurrency";
        message = "";
        return "viewCountry";
    }

    public String showCountryDelete() {
        myAction = "deleteCountry";
        return "viewCountry";
    }
	public List<Currency> getSelectedCurrency() {
		return selectedCurrency;
	}

	public void setSelectedCapitals(List<Currency> selectedCapitals) {
		this.selectedCurrency = selectedCapitals;
	}
    public String getNamespace() {
        return FacesContext.getCurrentInstance().getViewRoot().getClientId(FacesContext.getCurrentInstance());
    }

}
